#include "fasta.h"




/// Thanks to Peter "sehr Ocker" for this great quick hack!

// ==============================================================
fasta_exception::fasta_exception()
// ==============================================================
{
}

// ==============================================================
std::string fasta_exception::what()
// ==============================================================
{
	return std::string("error while reading fasta file.\n");
}

// ==============================================================
fasta_reader::~fasta_reader()
// ==============================================================
{ fclose (fp_);}

// ==============================================================
fasta_reader::fasta_reader (const std::string &filename)
// ==============================================================
    :   fp_ (0), state_ (Void)
{
    fp_ = fopen (filename.c_str(), "rb");
	 if (!fp_)
		 throw fasta_exception();

}   


// ==============================================================
int fasta_reader::get_seq (std::string &header, std::string &seq)
// ==============================================================	
{
    int         result = -1;    // 0 = eof, 1 = good seq.

    if (state_ != Void)
	 {
		 throw fasta_exception();
	 }
		 
    header.clear ();
    seq.clear ();

    while (result == -1)
    {
        int     c = fgetc (fp_);

        switch (state_)
        {
            case Void:
                switch (c)
                {
                    case EOF:
                        result = 0;
                        state_ = Void;
                        break;

                    case ' ': case '\t': case '\n': case '\r':
                        break;

                    case '>':
                        state_ = Header;
                        //header.push_back (c);
                        break;
            
                    default:
							  throw fasta_exception();
                        break;
                }
                break;

            case Header:
                switch (c)
                {
                    case EOF:
                        result = 0;
                        break;

                    case '\n': case '\r':
                        state_ = Data;
                        break;

                    case '\001':    // ^A or Ctrl-A
							  //MWARN ("header contains Ctrl-A character (after %s)", header.c_str());
                        break;
    
                    default:
                        header.push_back (c);
                        break;
                }
                break;

            case Data:
					if (c=='>') {
						state_ = Void;
						ungetc (c, fp_);
						result = 1;
					} else if (c==EOF) {
						result = 1;
						state_ = Void;
					} else if ((c>='a' && c<='z') || (c>='A' && c<='Z')) {
						seq.push_back(c);
					}
                break;

            default:
					throw fasta_exception();
					break;
        }
    }

    return result;
}


