#include "simple_local_alignment.h"

#include<vector>

int best_local_alignment(const std::string& X, const std::string& Y, alignment_triple& result)
{
	int i,j,trace;

	float start_credit = 6.;
	float mismatch_penalty = -2.;

	int best_alignment_length = 0;
	alignment_triple best_alignment;
	best_alignment.pos_X = 0;
	best_alignment.pos_Y = 0;
	best_alignment.credit = 0.;
	
	std::vector<alignment_triple> A_1(Y.size()+1), A_2(Y.size()+1);
	std::vector<alignment_triple> A_prev, A_curr, A_tmp;

	int m = X.size();
	int n = Y.size();
	
	A_prev = A_1;
	A_curr = A_2;
	
	for (j=0; j<=n; j++)
	{
		A_prev[j].credit = start_credit;
	}
	
	for (i=1; i<=m; i++)
	{
		for (j=1; j<=n; j++)
		{
			A_curr[0].pos_X = i;
			A_curr[0].pos_Y = 0;
			A_curr[0].credit = start_credit;
			if (X[i-1]==Y[j-1]) {
				A_curr[j] = A_prev[j-1];
			} else {
				if (A_prev[j-1].credit-mismatch_penalty > 0.) {
					A_curr[j] = A_prev[j-1];
					A_curr[j].credit += mismatch_penalty;
					if (i-A_curr[j].pos_X > best_alignment_length)
					{
						best_alignment_length = i-A_curr[j].pos_X;
						best_alignment = A_curr[j];
					}
				} else {
					A_curr[j].pos_X = i;
					A_curr[j].pos_Y = j;
					A_curr[j].credit = start_credit;
				}
			}
		}
		A_tmp = A_prev;
		A_prev = A_curr;
		A_curr = A_tmp;
	}

	result = best_alignment;
	return best_alignment_length;
	
}
